package com.Groble.BusyIcon;

import com.unity3d.player.UnityPlayer;

import android.app.Activity;
import android.graphics.drawable.AnimationDrawable;
import android.os.Handler;
import android.os.Handler.Callback;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.RelativeLayout.LayoutParams;

/**
 * ٻ ǥ.
 * 
 * @author KYK
 */
public class Manager {
    // .
    public static boolean            THIS_DEBUG         = false;
    public final static String       LOG_TAG            = "Busy Icon";

    private static String            IMAGE_NAME         = "busy";
    private static int               IMAGE_WIDTH        = 500;
    private static int               IMAGE_HEIGHT       = 306;

    // , .
    private final static int         PROC_SHOW          = 1;
    private final static int         PROC_HIDE          = 0;

    private static Activity          mActivity          = null;
    private static Handler           mhProc             = null;
    private static boolean           mInited            = false;

    private static ViewGroup         mViewGroup         = null;
    private static RelativeLayout    mRelativeLayout    = null;
    private static LayoutParams      mLayoutParams      = new LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT);
    private static ImageView         mImageView         = null;
    private static AnimationDrawable mAnimationDrawable = null;
    
    /**
     * ʱȭ.
     * 
     * @param imageName ̹ ̸.
     * @param imageWidth ̹ .
     * @param imageHeight ̹ .
     * @param debug .
     */
    public static void initialize(String imageName, int imageWidth, int imageHeight, boolean debug) {
        IMAGE_NAME   = imageName;
        IMAGE_WIDTH  = imageWidth;
        IMAGE_HEIGHT = imageHeight;
        THIS_DEBUG   = debug;
    }
    
    //////////////////////////////////////////////////////////////////////////
    //                                                                      //
    // Android.                                                             //
    //                                                                      //
    //////////////////////////////////////////////////////////////////////////
    
    /**
     * .
     * 
     * @param activity Activity
     */
    public static void show(Activity activity) {
        proc(activity, PROC_SHOW, 0);
    }
    
    /**
     * .
     * 
     * @param activity Activity
     * @param delayMillis ó  ð.
     */
    public static void show(Activity activity, long delayMillis) {
        proc(activity, PROC_SHOW, delayMillis);
    }
    
    /**
     * .
     * 
     * @param activity Activity
     */
    public static void hide(Activity activity) {
        proc(activity, PROC_HIDE, 0);
    }
    
    /**
     * .
     * 
     * @param activity Activity
     * @param delayMillis ó  ð.
     */
    public static void hide(Activity activity, long delayMillis) {
        proc(activity, PROC_HIDE, delayMillis);
    }
    
    //////////////////////////////////////////////////////////////////////////
    //                                                                      //
    // Unity.                                                               //
    //                                                                      //
    //////////////////////////////////////////////////////////////////////////
    
    /**
     * .
     */
    public static void show() {
        proc(UnityPlayer.currentActivity, PROC_SHOW, 0);
    }
    
    /**
     * .
     * 
     * @param delayMillis ó  ð.
     */
    public static void show(long delayMillis) {
        proc(UnityPlayer.currentActivity, PROC_SHOW, delayMillis);
    }
    
    /**
     * .
     */
    public static void hide() {
        proc(UnityPlayer.currentActivity, PROC_HIDE, 0);
    }
    
    /**
     * .
     * 
     * @param delayMillis ó  ð.
     */
    public static void hide(long delayMillis) {
        proc(UnityPlayer.currentActivity, PROC_HIDE, delayMillis);
    }
    
    /**
     * ó.
     * 
     * @param activity Activity
     * @param proc ó .
     * @param delayMillis ó  ð.
     */
    private static void proc(Activity activity, int proc, long delayMillis) {
        if (THIS_DEBUG == true)
            Log.d(LOG_TAG, "proc(" + activity + ", " + proc + ", " + delayMillis + ")");
        
        if (mActivity != activity) {
            if (THIS_DEBUG == true)
                Log.w(LOG_TAG, "warning: change activity.");
            
            mActivity = activity;
            mInited   = false;
            
            if (mActivity == null) {
                if (THIS_DEBUG == true)
                    Log.e(LOG_TAG, "error: activity is null.");
                return;
            }
            
            mhProc = new Handler(mActivity.getMainLooper(), mcbProc);
        }
        
        else if (mActivity == null) {
            if (THIS_DEBUG == true)
                Log.e(LOG_TAG, "error: activity is null.");
            return;
        }
        
        Message msg = mhProc.obtainMessage();
        
        msg.what = proc;
        
        mhProc.removeMessages(PROC_SHOW);
        mhProc.removeMessages(PROC_HIDE);
        mhProc.sendMessageDelayed(msg, delayMillis);
    }
    
    /**
     *  ó.
     * 
     * RootView ǥ  , Unity ̾ƿ  ǥõ ʴ´.
     * RootView  ϰų    View ߰Ѵ.
     * 
     * ViewGroup Unity ̾ƿ ߰ص  ɻ  ֱ  show/hide  add, remove Ѵ.
     */
    private static Callback mcbProc = new Callback() {
        @Override
        public boolean handleMessage(Message msg) {
            if (THIS_DEBUG == true)
                Log.i(LOG_TAG, "handleMessage(" + msg + ")");
            
            if (mInited == false) {
                if (THIS_DEBUG == true)
                    Log.d(LOG_TAG, "initialize.");
                
                _R.init(mActivity);
                
                // Unity Activity ViewGroup .
                mViewGroup = (ViewGroup) mActivity.getWindow().getDecorView().getRootView();
                
                // Root ViewGroup .
                mRelativeLayout = new RelativeLayout(mActivity);
                
                // Center ImageView ߰.
                LayoutParams layoutParams;
                
                mImageView = new ImageView(mActivity);
                mImageView.setBackgroundResource(_R.drawable(IMAGE_NAME));
                mImageView.setVisibility(View.INVISIBLE);
                
                mAnimationDrawable = (AnimationDrawable) mImageView.getBackground();
                
                layoutParams        = new LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
                layoutParams.addRule(RelativeLayout.CENTER_IN_PARENT);                
                layoutParams.width  = IMAGE_WIDTH;
                layoutParams.height = IMAGE_HEIGHT;
                mRelativeLayout.addView(mImageView, layoutParams);
                                
                //  View ߰.
                mRelativeLayout.addView(new View(mActivity), new LayoutParams(1, 1));
                
                mInited = true;
            }
            
            // ó.
            switch (msg.what) {
                case PROC_SHOW:
                    
                    mViewGroup.removeView(mRelativeLayout);
                    mViewGroup.addView(mRelativeLayout, mLayoutParams);                        
                    mImageView.setVisibility(View.VISIBLE);
                    mAnimationDrawable.start();
                    return false;
                    
                case PROC_HIDE:
                    
                    mImageView.setVisibility(View.INVISIBLE);
                    mAnimationDrawable.stop();
                    mViewGroup.removeView(mRelativeLayout);
                    return false;
            }
            return false;
        }
    };
}
